#include <ESP8266WiFi.h>
#include <ESPAsyncTCP.h>
#include <ESPAsyncWebServer.h>
#include <AsyncElegantOTA.h>
#include <PubSubClient.h>

#define relayPin 12     // the number of the relay pin
#define ledPin  13    // the number of the LED pin

// Update these with values suitable for your network.

  const char* ssid = "................";
  const char* password = "................";


AsyncWebServer server(80);

const char* mqtt_server = "...........";

WiFiClient espClient;
PubSubClient client(espClient);

// void ota
  void setup_OTA () {
    Serial.begin(115200);
    WiFi.mode(WIFI_STA);
    WiFi.begin(ssid, password);
    
    // Wait for connection
    while (WiFi.status() != WL_CONNECTED) {
      
      delay(500);
     
    }
    server.on("/", HTTP_GET, [](AsyncWebServerRequest *request) {
      request->send(200, "text/plain", "Hi! I am MPASS_V1 of y'ello lab .");
    });


    AsyncElegantOTA.begin(&server, "YELLOLab", "Yellolab@Inphb1234");    // Start ElegantOTA
    server.begin();
      
  }

void callback(char* topic, byte* payload, unsigned int length) {
  for (int i = 0; i < length; i++) {
    Serial.print((char)payload[i]);
  }
  Serial.println();

  
  if ((char)payload[0] == '0') {
        digitalWrite(ledPin, LOW);
    digitalWrite(relayPin, LOW);   
  } 
  else if  ((char)payload[0] == '1')
  {
    digitalWrite(ledPin, HIGH);
   digitalWrite(relayPin, HIGH);

  }
 
}

void reconnect() {
  // Loop until we're reconnected
  while (!client.connected()) {
   
    // Create a random client ID
    String clientId = "ESP_mpass_v1";
    clientId += String(random(0xffff), HEX);
    // Attempt to connect
    if (client.connect("MPASS_V1")) {
      
      client.subscribe("005");
    } else {
      
      // Wait 5 seconds before retrying
      delay(5000);
    }
  }
}

void setup() {
  setup_OTA ();
  pinMode(relayPin, OUTPUT); 
  pinMode(ledPin, OUTPUT);
  client.setServer(mqtt_server, 1883);
  client.setCallback(callback);
}

void loop() {

  if (!client.connected()) {
    reconnect();
  }
  client.loop();
}
